void dsp_exec(int);
void dsp_init(void);
void dsp_interrupt(int);
void dsp_set_regbank(int);
int dsp_get_regbank(void);

typedef struct {
	signed long r0[32];
	signed long r1[32];
	BYTE z;
	BYTE n;
	BYTE c;
	DWORD pc;
	DWORD remain;
	INT64 acc;
	DWORD mod;
	DWORD irq_enable[6];
	DWORD irq_active[6];
	DWORD matrix_address;
	DWORD matrix_size;
	DWORD active;
	DWORD imask;
	DWORD regbank;
	signed long* reg;
	signed long* alt;
	DWORD divide;
	DWORD interrupt_stack[128];
	int i_pointer;
	DWORD oldpc;
} DSPSTATE;

const BYTE dsp_opcode_times[64] =
{  3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
   3, 3, 1, 3, 1,18, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
   3, 3, 2, 2, 2, 2, 3, 6, 6, 4, 6, 6, 6, 1, 1, 1,
   1, 2, 2, 2, 1, 1,20, 3, 3, 1, 6, 6, 2, 2, 3, 3 };